Loading...
Searching...
No Matches
casacore::FrequencyUDF Class Reference
meas package (libcasa_meas) » MeasUDF_module

More...

`#include <FrequencyUDF.h>`

## Public Types

enum | FuncType { FREQUENCY , REST , SHIFT }
| Define the possible function types. More...
Public Types inherited from casacore::UDFBase
typedef UDFBase * | MakeUDFObject(const String &functionName)
| The signature of a global or static member function creating an object of the UDF.

## Public Member Functions

| FrequencyUDF (FuncType)
| Create for the given function type.
virtual void | setup (const Table &, const TaQLStyle &)
| Setup the object.
virtual Double | getDouble (const TableExprId &id)
| Get the value.
virtual MArray< Double > | getArrayDouble (const TableExprId &id)
Public Member Functions inherited from casacore::UDFBase
| UDFBase ()
| Only default constructor is needed.
virtual | ~UDFBase ()
| Destructor.
virtual Bool | getBool (const TableExprId &id)
| Evaluate the function and return the result.
virtual Int64 | getInt (const TableExprId &id)
virtual DComplex | getDComplex (const TableExprId &id)
virtual String | getString (const TableExprId &id)
virtual TaqlRegex | getRegex (const TableExprId &id)
virtual MVTime | getDate (const TableExprId &id)
virtual MArray< Bool > | getArrayBool (const TableExprId &id)
virtual MArray< Int64 > | getArrayInt (const TableExprId &id)
virtual MArray< DComplex > | getArrayDComplex (const TableExprId &id)
virtual MArray< String > | getArrayString (const TableExprId &id)
virtual MArray< MVTime > | getArrayDate (const TableExprId &id)
const String & | getUnit () const
| Get the unit.
const Record & | getAttributes () const
| Get the attributes.
virtual void | flattenTree (std::vector< TableExprNodeRep * > &)
| Flatten the node tree by adding the node and its children to the vector.
void | init (const std::vector< TENShPtr > &arg, const TableExprInfo &tableInfo, const TaQLStyle &)
| Initialize the function object.
TableExprNodeRep::NodeDataType | dataType () const
| Get the data type.
Int | ndim () const
| Get the dimensionality of the results.
const IPosition & | shape () const
| Get the result shape if the same for all results.
Bool | isConstant () const
| Tell if the UDF gives a constant result.
Bool | isAggregate () const
| Tell if the UDF is an aggregate function.
void | disableApplySelection ()
| Do not apply the selection.
void | applySelection (const Vector< rownr_t > &rownrs)
| If needed, let the UDF re-create column objects for a selection of rows.

## Static Public Member Functions

static UDFBase * | makeFREQ (const String &)
| Function to create an object.
static UDFBase * | makeREST (const String &)
static UDFBase * | makeSHIFT (const String &)
Static Public Member Functions inherited from casacore::UDFBase
static void | registerUDF (const String &name, MakeUDFObject *func)
| Register the name and construction function of a UDF (thread-safe).
static UDFBase * | createUDF (const String &name, const TaQLStyle &style)
| Create a UDF object (thread-safe).

## Private Member Functions

Bool | handleRadVelDoppler (uInt &argnr, Bool mustRadVel)
| Handle a radial velocity or optionally doppler for REST conversion.

## Private Attributes

FrequencyEngine | itsEngine
DopplerEngine | itsDopplerEngine
RadialVelocityEngine | itsRadVelEngine
DirectionEngine | itsDirectionEngine
EpochEngine | itsEpochEngine
PositionEngine | itsPositionEngine
FuncType | itsType
MFrequency::Types | itsRefType

## Additional Inherited Members

Protected Member Functions inherited from casacore::UDFBase
std::vector< TENShPtr > & | operands ()
| Get the operands.
void | setDataType (TableExprNodeRep::NodeDataType)
| Set the data type.
void | setNDim (Int ndim)
| Set the dimensionality of the results.
void | setShape (const IPosition &shape)
| Set the shape of the results if it is fixed and known.
void | setUnit (const String &unit)
| Set the unit of the result.
void | setAttributes (const Record &attributes)
| Set the attributes of the result.
void | setConstant (Bool isConstant)
| Define if the result is constant (e.g.
void | setAggregate (Bool isAggregate)
| Define if the UDF is an aggregate function (usually used in GROUPBY).
virtual void | recreateColumnObjects (const Vector< rownr_t > &rownrs)
| Let a derived class recreate its column objects in case a selection has to be applied.

## Detailed Description

TaQL UDFs for Frequency conversions.

### Intended use:

Public interface

### Review Status

Test programs:
  tMeas

### Prerequisite

- UDFBase

### Synopsis

FrequencyUDF defines UDFs (user defined functions) that can be used in TaQL to convert Measures for frequencys. Special functions exist to convert to hourangle and azimuth/elevation. In this way such derived values appear to be ordinary TaQL functions.

A function is called like:

meas.dir (toref, dir, time, pos)
meas.dir (toref, dir, time, pos)
For example,
meas.dir ('B1950', [2rad,1rad])
meas.dir ('B1950', [[2rad,1rad], 'J2000'])
meas.dir ('APP', 'MOON', TIME, [[5d12m, 52deg, 11m], 'WGS84'])
meas.dir ('APP', 'MOON', TIME, POSITION)
Or
meas.dir (toref, fromref, dir, pos, time)
casacore::time
TableExprNode time(const TableExprNode &node)
Definition ExprNode.h:1584

- toref is a single constant string.
- dir can have various value types. A single numeric array is a series of RA,DEC in J2000. If given as a set, the last argument of the set can be the reference types of the values in the set. The values can be strings (indicating planetary objects) or value pairs giving lon,lat. The default reference type is J2000.

All functions have data type double and unit radian.

### Motivation

It makes it possible to handle measures in TaQL.

Definition at line 90 of file FrequencyUDF.h.

## Member Enumeration Documentation

## FuncType

enum casacore::FrequencyUDF::FuncType

Define the possible function types.

Enumerator
FREQUENCY |
REST |
SHIFT |

Definition at line 94 of file FrequencyUDF.h.

## Constructor & Destructor Documentation

## FrequencyUDF()

casacore::FrequencyUDF::FrequencyUDF | ( | FuncType |  | ) |

explicit

Create for the given function type.

## Member Function Documentation

## getArrayDouble()

virtual MArray< Double > casacore::FrequencyUDF::getArrayDouble | ( | const TableExprId & | id | ) |

virtual

Reimplemented from casacore::UDFBase.

## getDouble()

virtual Double casacore::FrequencyUDF::getDouble | ( | const TableExprId & | id | ) |

virtual

Get the value.

Reimplemented from casacore::UDFBase.

## handleRadVelDoppler()

Bool casacore::FrequencyUDF::handleRadVelDoppler | ( | uInt & | argnr,
|  | Bool | mustRadVel )

private

Handle a radial velocity or optionally doppler for REST conversion.

It returns True if Doppler is used.

## makeFREQ()

UDFBase * casacore::FrequencyUDF::makeFREQ | ( | const String & |  | ) |

static

Function to create an object.

References casacore::UDFBase::UDFBase().

## makeREST()

UDFBase * casacore::FrequencyUDF::makeREST | ( | const String & |  | ) |

static

References casacore::UDFBase::UDFBase().

## makeSHIFT()

UDFBase * casacore::FrequencyUDF::makeSHIFT | ( | const String & |  | ) |

static

References casacore::UDFBase::UDFBase().

## setup()

virtual void casacore::FrequencyUDF::setup | ( | const Table & | ,
|  | const TaQLStyle & | )

virtual

Setup the object.

Implements casacore::UDFBase.

## Member Data Documentation

## itsDirectionEngine

DirectionEngine casacore::FrequencyUDF::itsDirectionEngine

private

Definition at line 120 of file FrequencyUDF.h.

## itsDopplerEngine

DopplerEngine casacore::FrequencyUDF::itsDopplerEngine

private

Definition at line 118 of file FrequencyUDF.h.

## itsEngine

FrequencyEngine casacore::FrequencyUDF::itsEngine

private

Definition at line 117 of file FrequencyUDF.h.

## itsEpochEngine

EpochEngine casacore::FrequencyUDF::itsEpochEngine

private

Definition at line 121 of file FrequencyUDF.h.

## itsPositionEngine

PositionEngine casacore::FrequencyUDF::itsPositionEngine

private

Definition at line 122 of file FrequencyUDF.h.

## itsRadVelEngine

RadialVelocityEngine casacore::FrequencyUDF::itsRadVelEngine

private

Definition at line 119 of file FrequencyUDF.h.

## itsRefType

MFrequency::Types casacore::FrequencyUDF::itsRefType

private

Definition at line 124 of file FrequencyUDF.h.

## itsType

FuncType casacore::FrequencyUDF::itsType

private

Definition at line 123 of file FrequencyUDF.h.

The documentation for this class was generated from the following file:

- meas/MeasUDF/FrequencyUDF.h